//-----------------------------------------------------------------------
// 饯ǥХɥ饤
// lcdsw.c  for CAT709, CAT760
//
// for linux-2.6 kernel          written by S.Shintani
//                                          Y.Ebihara
//-----------------------------------------------------------------------

#include <linux/module.h>
#include <linux/fs.h>
#include <linux/config.h>
#include <linux/proc_fs.h>
#include <linux/fs.h>
#include <linux/poll.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/vmalloc.h>
#include <linux/delay.h>
#include <linux/timer.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/semaphore.h>
#include <asm/system.h>
#include <asm/cpu/port.h>

#include "lcdsw.h"

#define	DEFAULT_MAJOR_NUM	243
#define	DEVNAME				"lcdsw"
#define	PROCNAME			"lcdsw"

#define LCDPOSX(arg) (((arg>>8)>15)?15:(arg>>8))
#define LCDPOSY(arg) (((arg&0xff)>0)?0x40:0)

enum NINORS{
	LCDSW,
	MAX_MINOR
};

// global var
static int major=DEFAULT_MAJOR_NUM;
MODULE_PARM(major,"i");


wait_queue_head_t lcdsw_wait;
static struct semaphore lcdsw_sem;

volatile static char swdata = 0;
volatile static char swread = 0;

// Display:ON Cursor:ON Blink:ON
static unsigned char functionset = 0x0f;
static struct timer_list tl;

//-----------------------------------------------------------------------
// åξ֤
//-----------------------------------------------------------------------
#if 0
static inline unsigned char lcdsw_read_sw(void)
{
	unsigned char swb1,swb2;
	int i,c;

	// ñʥ㥿
	swb2 = ~ctrl_inb(PORT_PCDR);
	for( i=0,c=0; i<10000; i++ ){
		udelay(100);
		swb1 = ~ctrl_inb(PORT_PCDR);
		if( swb1 == swb2 ){
			c++;
			// Ʊͤʾ³
			if( c >= 3 ){
				break;
			}
		}
		else{
			c = 0;
		}
		swb2 = swb1;
	}
	if( i == 10000 ){
		printk("read sw time out.\n");
		return 0; // Timeout
	}
	return swb1 & 0x1f;
}
#endif


//-----------------------------------------------------------------------
// LCDȥؤΥʥϡɥ dependʬ
//-----------------------------------------------------------------------

#define LCD_PORT	((volatile unsigned char*)PORT_PDDR)
#define LCD_RS_BIT	(1<<5)
#define LCD_E_BIT	(1<<7)
#define LCD_DATA_MASK 0x0f

void lcdsw_write_lcd_ctrl_4bit(unsigned char data){
	unsigned char x;
	unsigned long flags;
	local_irq_save(flags);
		data &= LCD_DATA_MASK;
		x = *LCD_PORT;
		x &= ~LCD_DATA_MASK;
		x |= data;
		*LCD_PORT = x;
	local_irq_restore(flags);
}

void lcdsw_write_lcd_ctrl_rs(int rs){
	unsigned long flags;
	local_irq_save(flags);
		if(rs)
			*LCD_PORT |= LCD_RS_BIT;
		else
			*LCD_PORT &= ~LCD_RS_BIT;
	local_irq_restore(flags);
}

void lcdsw_write_lcd_ctrl_e(int e){
	unsigned long flags;
	local_irq_save(flags);
		if(e)
			*LCD_PORT |= LCD_E_BIT;
		else
			*LCD_PORT &= ~LCD_E_BIT;
	local_irq_restore(flags);
}

static inline void lcdsw_write_lcd_out_4bit(unsigned char value)
{
	lcdsw_write_lcd_ctrl_4bit(value);
	udelay(1);
	lcdsw_write_lcd_ctrl_e(1);
	udelay(250);
	lcdsw_write_lcd_ctrl_e(0);
	udelay(250);
}

//-----------------------------------------------------------------------
// LCDȥؤΥȥ 쥸 
//-----------------------------------------------------------------------

static inline void lcdsw_write_lcd_ctrl(unsigned char ctrl)
{
	lcdsw_write_lcd_ctrl_rs(0);
	// ž
	lcdsw_write_lcd_out_4bit(ctrl >> 4);
	// ž
	lcdsw_write_lcd_out_4bit(ctrl);
}

//-----------------------------------------------------------------------
// LCDȥؤΥǡ 쥸 
//-----------------------------------------------------------------------
static inline void lcdsw_write_lcd_data(unsigned char data)
{
	lcdsw_write_lcd_ctrl_rs(1);
	// ž
	lcdsw_write_lcd_out_4bit(data >> 4);
	// ž
	lcdsw_write_lcd_out_4bit(data);
}

//-----------------------------------------------------------------------
// 
//-----------------------------------------------------------------------
static void	lcdsw_init(void)
{
	printk("%s()\n",__FUNCTION__);
	PORT_CONTROL_BIT(PORT_PDCR, 0, POUT);	// LCD_D0
	PORT_CONTROL_BIT(PORT_PDCR, 1, POUT);	// LCD_D1
	PORT_CONTROL_BIT(PORT_PDCR, 2, POUT);	// LCD_D2
	PORT_CONTROL_BIT(PORT_PDCR, 3, POUT);	// LCD_D3
	PORT_CONTROL_BIT(PORT_PDCR, 5, POUT);	// LCD_RS
	PORT_CONTROL_BIT(PORT_PDCR, 7, POUT);	// LCD_E
	udelay(1);
	*LCD_PORT &= ~(LCD_E_BIT | LCD_RS_BIT | LCD_DATA_MASK);

#if 0
	// Function	set	4bit 2line 5x10dot
	lcdsw_write_lcd_ctrl(0x2c);
	// Entry mode set incliment
	lcdsw_write_lcd_ctrl(0x06);
	// Clear display
	lcdsw_write_lcd_ctrl(0x01);
	udelay(1700);
	// Cursor at home
	lcdsw_write_lcd_ctrl(0x02);
	udelay(1700);
#endif

	lcdsw_write_lcd_ctrl_rs(0);
	// 8bit mode set
	lcdsw_write_lcd_out_4bit(0x3);
	mdelay(5);

	// 8bit mode set
	lcdsw_write_lcd_out_4bit(0x3);
	mdelay(5);

	// 8bit mode set
	lcdsw_write_lcd_out_4bit(0x3);
	mdelay(5);

	// 4bit mode set
	lcdsw_write_lcd_out_4bit(0x2);
	mdelay(5);


	// Function	set	4bit 2line 5x10dot
	lcdsw_write_lcd_ctrl(0x2e);	 // was 0x2c
	mdelay(5);

	// Display on (C=D=1, B=0)
	lcdsw_write_lcd_ctrl(0x0D);
	mdelay(5);

	// Entry mode set incliment
	lcdsw_write_lcd_ctrl(0x06);
	mdelay(5);

	// Clear display
	lcdsw_write_lcd_ctrl(0x01);
	mdelay(5);

	// Cursor at home
	lcdsw_write_lcd_ctrl(0x02);
	mdelay(5);

}


//-----------------------------------------------------------------------
// IO-CTRL
//-----------------------------------------------------------------------
int lcdsw_ioctl(struct inode* inode, struct file* pfile, unsigned int request, unsigned long arg)
{
	int minor = MINOR(inode->i_rdev);
	unsigned char adr = 0;
	switch(request){
	// ̤Υꥢ
	case LCD_CLEAR:
		lcdsw_write_lcd_ctrl(0x01);
		udelay(1700);
		break;
	// ۡݥذư
	case LCD_HOME:
		// Cursor at home
		lcdsw_write_lcd_ctrl(0x02);
		udelay(1700);
		break;
	// ɽONOFFʥХåեϾäʤ
	case LCD_DISPLAY:
		if( arg ){
			functionset |= 0x04;
		}
		else{
			functionset &= 0x0b;
		}
		lcdsw_write_lcd_ctrl(functionset);
		break;
	// ɽONOFF
	case LCD_CURSOR:
		if( arg ){
			functionset |= 0x02;
		}
		else{
			functionset &= 0x0c;
		}
		lcdsw_write_lcd_ctrl(functionset);
		break;
	// ֥󥯤ONOFF
	case LCD_BLINK:
		if( arg ){
			functionset |= 0x01;
		}
		else{
			functionset &= 0x0e;
		}
		lcdsw_write_lcd_ctrl(functionset);
		break;
	// ݥΰư
	case LCD_LOCATE:
		adr |= LCDPOSX(arg);
		adr |= LCDPOSY(arg);
		lcdsw_write_lcd_ctrl(adr|0x80);
		break;
	// LCDȥΥꥻå
	case LCD_RESET:
		lcdsw_init();
		break;
#if 0
	case LED_RED:
		led_red(arg);
#endif
	}
	return 1;
}


//-----------------------------------------------------------------------
// ޡ
//-----------------------------------------------------------------------
void timer_func(unsigned long data)
{
	unsigned char swb = (~ctrl_inb(PORT_PCDR)) & 0x1f;
	int i;

	// ޤϴñ˥å
	if( swb != (unsigned char)(data&0x1f) ){
		int wakeup = 0;
		unsigned char chkb = 1;
		for( i=0; i<5; i++ ){
			// Ω夬å
			if( ((data&chkb)==0) && ((swb&chkb)!=0) ){
				swdata |= chkb;
				wakeup = 1;
			}
			// Ωå
			if( ((data&chkb)!=0) && ((swb&chkb)==0) ){
				swdata &= (~chkb);
			}
			chkb <<= 1;
		}
		if( wakeup ){
			swread = 1;
			wake_up_interruptible(&lcdsw_wait);
		}
	}
	init_timer(&tl);
	tl.expires = jiffies + HZ/100; // 10ms
	tl.data = (unsigned long)swb;
	tl.function = timer_func;
	add_timer(&tl);
}


//-----------------------------------------------------------------------
// OPEN
//-----------------------------------------------------------------------
static int lcdsw_open(struct inode *inode, struct file *filp)
{
	int minor = MINOR(inode->i_rdev);
	if(minor >=	MAX_MINOR){
		printk("<1>lcdsw open()	error\n");
		return -ENODEV;
	}
	filp->private_data = (void*)minor;

	switch(minor){
	case LCDSW:
		// Clear display
		lcdsw_write_lcd_ctrl(0x01);
		udelay(1700);
		// Cursor at home
		lcdsw_write_lcd_ctrl(0x02);
		udelay(1700);
		// Display:ON Cursor:ON Blink:ON
		lcdsw_write_lcd_ctrl(functionset);

		init_timer(&tl);
		tl.expires = jiffies + HZ/100; // 10ms
		swdata = 0;
		tl.data = (unsigned long)swdata;
		tl.function = timer_func;
		add_timer(&tl);
		break;
	}
	return 0;
}


//-----------------------------------------------------------------------
// CLOSE
//-----------------------------------------------------------------------
static int lcdsw_close(struct inode	*inode,	struct file	*filp)
{
	int minor;

	minor = (int)(filp->private_data);
	switch(minor){
	case LCDSW:
		del_timer(&tl);
		break;
	}
	return 0;
}


//-----------------------------------------------------------------------
// WRITE
//-----------------------------------------------------------------------
static int lcdsw_write(struct file *filp, const	char *user_buf,size_t count,loff_t *ppos)
{
	unsigned char buffer[64];
	unsigned char addr;
	int size;
	int	minor;
	int	i;
	int j;

	minor = (int)(filp->private_data);
	size = count;
	if( size > 64 ) size = 64;
	copy_from_user(buffer,user_buf,size);

	switch(minor){
	case LCDSW:
		addr = 0;
		for( i=0,j=0; i<size; i++ ){
			if( buffer[i] == '@' ){
				// @@
				if( ((i+1)<size) && buffer[i+1]=='@' ){
					lcdsw_write_lcd_data(buffer[i]);
					i++;
				}
				// DDRAM address set
				// @XY
				else if( ((i+2)<size) ){
					addr  = (buffer[i+1]<'A') ? (buffer[i+1]-'0') : (10+buffer[i+1]-'A');
					addr |= (buffer[i+2]=='0') ? 0x00 : 0x40;
					lcdsw_write_lcd_ctrl(addr|0x80);
					i+=2;
				}
			}
			else if( (buffer[i]>=0x20 && buffer[i]<0x80) || buffer[i]>0xA0 ){
				lcdsw_write_lcd_data(buffer[i]);
			}
		}
		return size;
	}
	return -ENODEV;
}



//-----------------------------------------------------------------------
// READ
//-----------------------------------------------------------------------
static int lcdsw_read(struct file *filp, char *user_buf,size_t count,loff_t	*ppos)
{
	int	minor;

	minor =	(int)(filp->private_data);
	switch(minor){
	case LCDSW:
		copy_to_user(user_buf,&swdata,1);
		swread = 0;
	//	swdata = 0;
		return 1;
	}
	return -ENODEV;
}

//-----------------------------------------------------------------------
// POLL for select()
//-----------------------------------------------------------------------
unsigned int lcdsw_poll(struct file	*filp, poll_table *wait)
{
	int	ch;
	unsigned int mask=0;

	ch = (int)(filp->private_data);
	if( ch == LCDSW ){
		poll_wait(filp, &lcdsw_wait, wait);
		if( swread ){
			mask |=	POLLIN | POLLRDNORM; //	it is readable;
		}
		return mask;
	}
	mask |=	POLLIN | POLLRDNORM; //	it is readable;
	return mask;
}

static struct file_operations lcdsw_fops = {
	owner:THIS_MODULE,    // ޤʤ
	open:lcdsw_open,      // open
	read:lcdsw_read,      // read
	write:lcdsw_write,    // write
	poll:lcdsw_poll,      // poll
	release:lcdsw_close,  // close
	ioctl:lcdsw_ioctl
};

//-----------------------------------------------------------------------
// 
//-----------------------------------------------------------------------
static int lcdsw_initmodule(void)
{
	printk("<1>lcdsw hello major=%d	\n",major);

#define LDCNTR  ((unsigned volatile short*) 0xbe300c28)
	if ((*LDCNTR & 1) == 1){
		printk("LCD panel in use. %s can't start\n",DEVNAME);
		return -EBUSY;
	}

	// ϡɥŪʽ
	lcdsw_init();

	if(register_chrdev(major,DEVNAME,&lcdsw_fops) != 0){
		printk("<1>lcdsw register fail\n");
		return -1;
	}

	sema_init(&lcdsw_sem, 1);
	init_waitqueue_head(&lcdsw_wait);

	return 0;
}

//-----------------------------------------------------------------------
// λ
//-----------------------------------------------------------------------
static void	lcdsw_exitmodule(void)
{
	printk("<1>lcdsw goodby\n");
	unregister_chrdev(major,DEVNAME);
}

module_init(lcdsw_initmodule);
module_exit(lcdsw_exitmodule);

MODULE_LICENSE("GPL");

